﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ImpressaoDireta
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            CarregarImpressoras();
        }

        private void CarregarImpressoras()
        {
            impressoraComboBox.Items.Clear();

            foreach (var impressora in System.Drawing.Printing.PrinterSettings.InstalledPrinters)
            {
                impressoraComboBox.Items.Add(impressora);
            }
        }

        private void imprimirButton_Click(object sender, EventArgs e)
        {
            using (var pd = new System.Drawing.Printing.PrintDocument())
            {
                pd.PrinterSettings.PrinterName = impressoraComboBox.SelectedItem.ToString();
                pd.PrintPage += Pd_PrintPage;
                _texto = impressaoTextBox.Text;
                pd.Print();
            }
        }

        private string _texto;
        private void Pd_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            using (var font = new Font("Times New Roman", 14))
            using (var brush = new SolidBrush(Color.Black))
            {
                int caracteres = 0;
                int linhas = 0;

                e.Graphics.MeasureString(_texto, font, new Size(e.MarginBounds.Width, e.MarginBounds.Height - font.Height + 1), StringFormat.GenericTypographic, out caracteres, out linhas);

                e.Graphics.DrawString(_texto.Substring(0, caracteres), font, brush, e.MarginBounds);

                _texto = _texto.Substring(caracteres);

                e.HasMorePages = !string.IsNullOrWhiteSpace(_texto);
            }
        }
    }
}
